'''
Started on: 2011.07.20
Last update: 2011.11.30
Author: Kulverstukas && Factionwars

=================================================
Copyright 2011 Kulverstukas, Factionwars

    This file is part of D0xBase.

    D0xBase is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation version 3

    D0xBase is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with D0xBase.  If not, see http://www.gnu.org/licenses/
=================================================

Shouts: Evilzone.org
You can contact us at: kulverwars@evilzone.org
--------
Description:
  This module is part of "D0xBase" project.
  Any modification without knowing what you are doing will result
  in unwanted behavior and can stop working.
  
  This module is the front-end of D0xBase to give
  graphical interface.
--------
'''

'''
======
Fonts:
urwid.font.Thin3x3Font
urwid.font.Thin4x3Font
urwid.font.HalfBlock5x4Font
urwid.font.HalfBlock6x5Font
urwid.font.HalfBlockHeavy6x5Font
urwid.font.Thin6x6Font
urwid.font.HalfBlock7x7Font
======
'''
#======================================
import urwid
import d0xtext
import d0xengine
import d0xconfigwizard

import string
import time
import os
import random
import datetime
import ConfigParser
from optparse import OptionParser
#======================================
__version__ = '0.2'
#======================================
#Global vars
EditFieldsList = urwid.ListBox
Information = []
INPUT = []
RadioButtons = []
withBanner = urwid.AttrWrap(urwid.Overlay(urwid.BigText('D0xBase %s' % __version__, urwid.font.HalfBlock7x7Font()), urwid.SolidFill(' '), 'center', None, 'top', None), 'BigText')
withoutBanner = urwid.AttrMap(urwid.SolidFill(' '), 'BigText')
CameToEdit = False
SearchField = urwid.Edit()
IntEdit = urwid.IntEdit()
#construct a configuration parser
config = ConfigParser.RawConfigParser()
#create a class that holds the text
texts = d0xtext.d0xtext()
palette = texts.getPalette()
wiz = d0xconfigwizard.check()
#======================================
class FrontEnd:
#======================================
    def CalculateAge(self, Date):
        '''Calculates the age and days until next birthday
           from the given birth date to display in the results'''
        try:
            for I in './- ':
                if (Date.find(I) != -1):
                    Date = Date.split(I)
                    break;
            BirthDate = datetime.date(int(Date[0]), int(Date[1]), int(Date[2]))
            Today = datetime.date.today()
    
            if (Today.month > BirthDate.month):
                NextYear = datetime.date(Today.year + 1, BirthDate.month, BirthDate.day)
            elif (Today.month < BirthDate.month):
                NextYear = datetime.date(Today.year, Today.month + (BirthDate.month - Today.month), BirthDate.day)
            elif (Today.month == BirthDate.month):
                if (Today.day > BirthDate.day):
                    NextYear = datetime.date(Today.year + 1, BirthDate.month, BirthDate.day)
                elif (Today.day < BirthDate.day):
                    NextYear = datetime.date(Today.year, BirthDate.month, Today.day + (BirthDate.day - Today.day))
                elif (Today.day == BirthDate.day):
                    NextYear = 0

            Age = Today.year - BirthDate.year

            if NextYear == 0: #if today is the birthday
                return '%d, days until %d: %d' % (Age, Age+1, 0)
            else:
                DaysLeft = NextYear - Today
                return '%d, days until %d: %d' % (Age, Age+1, DaysLeft.days)
        except:
            return 'Date not entered or format incorrect'
#======================================
    def CalculateDays(self, Date):
        '''Calculates number of days the record was not modified
           to display in the results'''
        try:
            Date = Date.split('.')
            Date = datetime.date(int(Date[0]), int(Date[1]), int(Date[2]))
            Today = datetime.date.today()
            DaysSince = Today - Date
            return '%d.%d.%d, days since then: %d' % (Date.year, Date.month, Date.day, DaysSince.days)
        except:
             return 'Wrong date format was given'
#======================================
    def CheckDate(self, Str):
        '''Checks the date if it is in a valid format
           when adding a record'''
        try:
            if (time.strptime(Str, '%Y.%m.%d')): return True
        except:
            return False
#======================================
    def FormatOutput(self, Input):
        '''Formats the input into two columns with proper
           alignment and outputs a table of information'''
        Age = self.CalculateAge(INPUT[5]) #can has age?
        #Input = FrontEnd().ReplaceBlanks(Input)
        if (len(Input) != 17): #oh shii-- something is missing!
            return urwid.ListBox(urwid.SimpleListWalker([urwid.Text(('LastModifiedField', 'Error in database output. Try restarting the program.'))]))

        Output = [
           urwid.Columns([urwid.Padding(urwid.Text([
               ('LastModifiedField', 'Last modified: '), ('LastModifiedDate', self.CalculateDays(Input[16])+'\n\n')
                                                   ], align='center'), left=10)], 1),
           urwid.Columns([urwid.Text([('Field', 'Name: '), ('Info', Input[1])]), 
                          urwid.Text([('Field', 'Last name: '), ('Info', Input[2])])
                         ], 2),
           urwid.Columns([urwid.Text([('Field', 'Nickname: '), ('Info', Input[3])]),
                          urwid.Text([('Field', 'Gender: '), ('Info', Input[4])])
                         ], 2),
           urwid.Columns([urwid.Text([('Field', 'Date of birth: '), ('Info', Input[5])]),
                          urwid.Text([('Field', 'Place of birth: '), ('Info', Input[6])])
                         ], 2),
           urwid.Columns([urwid.Text([('Field', 'Date of death: '), ('Info', Input[7])]),
                          urwid.Text([('Field', 'Place of death: '), ('Info', Input[8])])
                         ], 2),
           urwid.Columns([urwid.Text([('Field', 'Age: '), ('Info', Age.ljust(31))]),
                          urwid.Text([('Field', 'Location: '), ('Info', Input[9])])
                         ], 2),
           urwid.Columns([urwid.Text([('Field', 'Email: '), ('Info', Input[10])]),
                          urwid.Text([('Field', 'Education: '), ('Info', Input[11])])
                         ], 2),
           urwid.Columns([urwid.Text([('Field', 'Occupation: '), ('Info', Input[12])]),
                          urwid.Text([('Field', 'Workplace: '), ('Info', Input[13])])
                         ], 2),
           urwid.Columns([urwid.Text([('Field', 'Contact:\n'), ('Info', Input[14])]),
                          urwid.Text([('Field', 'Notes:\n'), ('Info', Input[15])])
                         ], 2)
                 ]
        return urwid.ListBox(urwid.SimpleListWalker(Output))
#======================================
    def ShowInfo(self):
        '''Part of the Search method.
           Search calls this method to display selected data'''
           
        #Footer
        Footer = urwid.AttrMap(urwid.Text(texts.getFooterViewText(), align='center'), 'InfoFooter')

        #Header
        headerTxt = ''
        if  (config.get('main', 'program_version') == 'y'):
            headerTxt += texts.getHeaderText(__version__)+' / '
        headerTxt += 'Viewing'
        if (config.get('main', 'display_id_viewing') == 'y'):
            headerTxt += ' ID: [%s]' % INPUT[0]
        Header = urwid.AttrWrap(urwid.Text(('InfoHeaderText', headerTxt), align='center'), 'InfoHeader')

        PaddedBody = urwid.Overlay(FrontEnd().FormatOutput(INPUT), urwid.SolidFill(' '), 'center', 80, 'middle', 20)
        HeadBodyFootFrame = urwid.Frame(body=PaddedBody, header=Header, footer=Footer)

        #Background
        Bkg = urwid.AttrWrap(HeadBodyFootFrame, 'Bg')
        #Bkg = urwid.LineBox(Bkg)

        #Deletion popup
        Delete = urwid.Text(('PopupMessageText', 'Are you sure you want to delete it?\n[Y/N]'), align='center')
        Delete = urwid.AttrWrap(urwid.Overlay(urwid.LineBox(Delete, title='|** Confirm **|'), Bkg, 'center', 40, 'middle', None), 'PopupMessageBg')
        
        #No more records warning
        noRecord = urwid.AttrWrap(urwid.Overlay(urwid.LineBox(texts.getNoRecordsWarning(), title='|** Information **|'), Bkg, 'center', 40, 'middle', None), 'PopupMessageBg')

        return  Bkg, Delete, noRecord
#======================================
    def ShowAdd(self):
        '''This is the adding screen'''
        global EditFieldsList

        #Footer
        Footer = urwid.AttrMap(urwid.Text(texts.getFooterAddingText(), align='center'), 'InfoFooter')

        #Header
        headerTxt = ''
        if (config.get('main', 'program_version') == 'y'):
            headerTxt += texts.getHeaderText(__version__)+' / '
        headerTxt += 'Adding'
        if (config.get('main', 'display_id_adding') == 'y'):
            headerTxt += ' ID: [%s]' % (gap)
        Header = urwid.AttrMap(urwid.Text(('InfoHeaderText', headerTxt), align='center'), 'InfoHeader')

        EditFields = urwid.SimpleListWalker([
                       urwid.AttrWrap(urwid.Edit(('Field', 'Name'.ljust(16,'.')+': ')), 'Info', 'OnFocusBg'),
                       urwid.Divider(),
                       urwid.AttrWrap(urwid.Edit(('Field', 'Last name'.ljust(16,'.')+': ')), 'Info', 'OnFocusBg'),
                       urwid.Divider(),
                       urwid.AttrWrap(urwid.Edit(('Field', 'Nickname'.ljust(16,'.')+': ')), 'Info', 'OnFocusBg'),
                       urwid.Divider(),
                       urwid.AttrWrap(urwid.Edit(('Field', 'Gender'.ljust(16,'.')+': ')), 'Info', 'OnFocusBg'),
                       urwid.Divider(),
                       urwid.AttrWrap(urwid.Edit(('Field', 'Date of birth'.ljust(16,'.')+': ')), 'Info', 'OnFocusBg'),
                       urwid.Divider(),
                       urwid.AttrWrap(urwid.Edit(('Field', 'Place of birth.'.ljust(16,'.')+': ')), 'Info', 'OnFocusBg'),
                       urwid.Divider(),
                       urwid.AttrWrap(urwid.Edit(('Field', 'Date of death'.ljust(16,'.')+': ')), 'Info', 'OnFocusBg'),
                       urwid.Divider(),
                       urwid.AttrWrap(urwid.Edit(('Field', 'Place of death'.ljust(16,'.')+': ')), 'Info', 'OnFocusBg'),
                       urwid.Divider(),
                       urwid.AttrWrap(urwid.Edit(('Field', 'Location'.ljust(16,'.')+': ')), 'Info', 'OnFocusBg'),
                       urwid.Divider(),
                       urwid.AttrWrap(urwid.Edit(('Field', 'Email address'.ljust(16,'.')+': ')), 'Info', 'OnFocusBg'),
                       urwid.Divider(),
                       urwid.AttrWrap(urwid.Edit(('Field', 'Education'.ljust(16,'.')+': ')), 'Info', 'OnFocusBg'),
                       urwid.Divider(),
                       urwid.AttrWrap(urwid.Edit(('Field', 'Occupation'.ljust(16,'.')+': ')), 'Info', 'OnFocusBg'),
                       urwid.Divider(),
                       urwid.AttrWrap(urwid.Edit(('Field', 'Workplace'.ljust(16,'.')+': ')), 'Info', 'OnFocusBg'),
                       urwid.Divider(),
                       urwid.AttrWrap(urwid.Edit(('Field', 'Contact'.ljust(16,'.')+': '), multiline=True), 'Info', 'OnFocusBg'),
                       urwid.Divider(),
                       urwid.AttrWrap(urwid.Edit(('Field', 'Notes'.ljust(16,'.')+': '), multiline=True), 'Info', 'OnFocusBg'),
                       urwid.Divider()
                                             ])
        Explanation = texts.getAddTips()
        EditFieldsList = urwid.ListBox(EditFields)
        Explanation = urwid.ListBox(Explanation)

        vline = urwid.AttrWrap(urwid.SolidFill('|'), 'Info')

        BodyWithInfo = urwid.Columns([('fixed', 40, Explanation),('fixed', 1, vline), EditFieldsList], dividechars=3, focus_column=2)
        HeadBodyFootFrame = urwid.Frame(footer=Footer, header=Header, body=BodyWithInfo)

        #Background
        Bkg = urwid.AttrWrap(HeadBodyFootFrame, 'Bg')

        #Empty Name field dialog
        Empty = urwid.AttrWrap(urwid.Overlay(urwid.LineBox(texts.getEmptyWarning(), title='|** Error **|'), Bkg, 'center', 40, 'middle', None), 'PopupMessageBg')

        #Wrong date popup
        WrongDate = urwid.AttrWrap(urwid.Overlay(urwid.LineBox(texts.getWrongDateWarning(), title='|** Error **|'), Bkg, 'center', 40, 'middle', None), 'PopupMessageBg')

        #Message to show when person is added
        Added = urwid.AttrWrap(urwid.Overlay(urwid.LineBox(texts.getAddedMessage(), title='|** Success **|'), Bkg, 'center', 40, 'middle', None), 'PopupMessageBg')

        #Message to show when canceling adding
        ReallyCancel = urwid.AttrWrap(urwid.Overlay(urwid.LineBox(texts.getReallyCancelMessage(), title='|** Confirm **|'), Bkg, 'center', 40, 'middle', None), 'PopupMessageBg')

        #Message to show when adding a record
        ReallyAdd = urwid.AttrWrap(urwid.Overlay(urwid.LineBox(texts.getReallyAddMessage(), title='|** Confirm **|'), Bkg, 'center', 40, 'middle', None), 'PopupMessageBg')

        return Bkg, Empty, WrongDate, Added, ReallyCancel, ReallyAdd
#======================================
    def ShowEditor(self):
        '''This is the editing screen'''
        global EditFieldsList
        #Footer
        Footer = urwid.AttrMap(urwid.Text(texts.getFooterAddingText(), align='center'), 'InfoFooter')

        #Header
        headerTxt = ''
        if (config.get('main', 'program_version') == 'y'):
            headerTxt += texts.getHeaderText(__version__)+' / '
        headerTxt += 'Editing'
        if (config.get('main', 'display_id_adding') == 'y'):
            headerTxt += ' ID: [%s]' % INPUT[0]
        Header = urwid.AttrMap(urwid.Text(('InfoHeaderText', headerTxt), align='center'), 'InfoHeader')

        EditFields = urwid.SimpleListWalker([
                       urwid.AttrWrap(urwid.Edit(('Field', 'Name'.ljust(16,'.')+': '), INPUT[1]), 'Info', 'OnFocusBg'),
                       urwid.Divider(),
                       urwid.AttrWrap(urwid.Edit(('Field', 'Last name'.ljust(16,'.')+': '), INPUT[2]), 'Info', 'OnFocusBg'),
                       urwid.Divider(),
                       urwid.AttrWrap(urwid.Edit(('Field', 'Nickname'.ljust(16,'.')+': '), INPUT[3]), 'Info', 'OnFocusBg'),
                       urwid.Divider(),
                       urwid.AttrWrap(urwid.Edit(('Field', 'Gender'.ljust(16,'.')+': '), INPUT[4]), 'Info', 'OnFocusBg'),
                       urwid.Divider(),
                       urwid.AttrWrap(urwid.Edit(('Field', 'Date of birth'.ljust(16,'.')+': '), INPUT[5]), 'Info', 'OnFocusBg'),
                       urwid.Divider(),
                       urwid.AttrWrap(urwid.Edit(('Field', 'Place of birth'.ljust(16,'.')+': '), INPUT[6]), 'Info', 'OnFocusBg'),
                       urwid.Divider(),
                       urwid.AttrWrap(urwid.Edit(('Field', 'Date of death'.ljust(16,'.')+': '), INPUT[7]), 'Info', 'OnFocusBg'),
                       urwid.Divider(),
                       urwid.AttrWrap(urwid.Edit(('Field', 'Place of death'.ljust(16,'.')+': '), INPUT[8]), 'Info', 'OnFocusBg'),
                       urwid.Divider(),
                       urwid.AttrWrap(urwid.Edit(('Field', 'Location'.ljust(16,'.')+': '), INPUT[9]), 'Info', 'OnFocusBg'),
                       urwid.Divider(),
                       urwid.AttrWrap(urwid.Edit(('Field', 'Email address'.ljust(16,'.')+': '), INPUT[10]), 'Info', 'OnFocusBg'),
                       urwid.Divider(),
                       urwid.AttrWrap(urwid.Edit(('Field', 'Education'.ljust(16,'.')+': '), INPUT[11]), 'Info', 'OnFocusBg'),
                       urwid.Divider(),
                       urwid.AttrWrap(urwid.Edit(('Field', 'Occupation'.ljust(16,'.')+': '), INPUT[12]), 'Info', 'OnFocusBg'),
                       urwid.Divider(),
                       urwid.AttrWrap(urwid.Edit(('Field', 'Workplace'.ljust(16,'.')+': '), INPUT[13]), 'Info', 'OnFocusBg'),
                       urwid.Divider(),
                       urwid.AttrWrap(urwid.Edit(('Field', 'Contact'.ljust(16,'.')+': '), INPUT[14], multiline=True), 'Info', 'OnFocusBg'),
                       urwid.Divider(),
                       urwid.AttrWrap(urwid.Edit(('Field', 'Notes'.ljust(16,'.')+': '), INPUT[15], multiline=True), 'Info', 'OnFocusBg'),
                       urwid.Divider(),
                                             ])
        Explanation = texts.getAddTips()
        EditFieldsList = urwid.ListBox(EditFields)
        Explanation = urwid.ListBox(Explanation)

        vline = urwid.AttrWrap(urwid.SolidFill('|'), 'Info')

        BodyWithInfo = urwid.Columns([('fixed', 40, Explanation),('fixed', 1, vline), EditFieldsList], dividechars=3, focus_column=2)
        HeadBodyFootFrame = urwid.Frame(footer=Footer, header=Header, body=BodyWithInfo)

        #Background
        Bkg = urwid.AttrWrap(HeadBodyFootFrame, 'Bg')
        #Bkg = urwid.LineBox(Bkg)

        #Empty Name field dialog
        Empty = urwid.AttrWrap(urwid.Overlay(urwid.LineBox(texts.getEmptyWarning(), title='|** Error **|'), Bkg, 'center', 40, 'middle', None), 'PopupMessageBg')

        #Wrong date popup
        WrongDate = urwid.AttrWrap(urwid.Overlay(urwid.LineBox(texts.getWrongDateWarning(), title='|** Error **|'), Bkg, 'center', 40, 'middle', None), 'PopupMessageBg')

        #Message to show when person is added
        Added = urwid.AttrWrap(urwid.Overlay(urwid.LineBox(texts.getAddedMessage(), title='|** Success **|'), Bkg, 'center', 40, 'middle', None), 'PopupMessageBg')

        #Message to show when canceling
        ReallyCancel = urwid.AttrWrap(urwid.Overlay(urwid.LineBox(texts.getReallyCancelMessage(), title='|** Confirm **|'), Bkg, 'center', 40, 'middle', None), 'PopupMessageBg')

        #Message to show when adding a record
        ReallyAdd = urwid.AttrWrap(urwid.Overlay(urwid.LineBox(texts.getReallyAddMessage(), title='|** Confirm **|'), Bkg, 'center', 40, 'middle', None), 'PopupMessageBg')

        return Bkg, Empty, WrongDate, Added, ReallyCancel, ReallyAdd
#======================================
    def ShowSearch(self):
        '''This is a search screen'''
        global RadioButtons, SearchField
        #Footer
        Footer = urwid.AttrMap(urwid.Text(texts.getFooterSearchText(), align='center'), 'InfoFooter')

        #Header
        Header = urwid.AttrMap(urwid.Text(('InfoHeaderText', '%s %s Searching' % (texts.getHeaderText(__version__), '/')), align='center'), 'InfoHeader')

        RadioGroup = []
        RadioButtons = []
        if (config.get('main', 'default_search_method') == 'id'):
            RadioButtons.append(urwid.AttrWrap(urwid.RadioButton(RadioGroup, 'ID', state=True), 'Info', 'OnFocusBg'))
        else: 
            RadioButtons.append(urwid.AttrWrap(urwid.RadioButton(RadioGroup, 'ID', state=False), 'Info', 'OnFocusBg'))
            
        if (config.get('main', 'default_search_method') == 'name'):
            RadioButtons.append(urwid.AttrWrap(urwid.RadioButton(RadioGroup, 'Name', state=True), 'Info', 'OnFocusBg'))
        else:
            RadioButtons.append(urwid.AttrWrap(urwid.RadioButton(RadioGroup, 'Name', state=False), 'Info', 'OnFocusBg'))
            
        if (config.get('main', 'default_search_method') == 'lastname'):
            RadioButtons.append(urwid.AttrWrap(urwid.RadioButton(RadioGroup, 'Last name', state=True), 'Info', 'OnFocusBg'))
        else:
            RadioButtons.append(urwid.AttrWrap(urwid.RadioButton(RadioGroup, 'Last name', state=False), 'Info', 'OnFocusBg'))
            
        if (config.get('main', 'default_search_method') == 'nickname'):
            RadioButtons.append(urwid.AttrWrap(urwid.RadioButton(RadioGroup, 'Nickname', state=True), 'Info', 'OnFocusBg'))
        else:
            RadioButtons.append(urwid.AttrWrap(urwid.RadioButton(RadioGroup, 'Nickname', state=False), 'Info', 'OnFocusBg'))
        
        SearchField = urwid.AttrWrap(urwid.Edit(('Field', 'Search: ')), 'Info', 'OnFocusBg')

        Bodeh = urwid.Pile([urwid.ListBox(urwid.SimpleListWalker([
                     urwid.Divider(),
                     SearchField,
                     urwid.Divider(),
                     urwid.AttrWrap(urwid.Text(('Field', 'Select by what to search:')), 'Bg'),
                     RadioButtons[0],
                     RadioButtons[1],
                     RadioButtons[2],
                     RadioButtons[3]]))
                           ])

        Explanation = urwid.ListBox(texts.getSearchTips())

        BodyWithInfo = urwid.Columns([('fixed', 40, Explanation), ('fixed', 1, urwid.AttrWrap(urwid.SolidFill('|'), 'Info')), Bodeh], dividechars=3, focus_column=2)
        HeadBodyFootFrame = urwid.Frame(footer=Footer, header=Header, body=BodyWithInfo)

        #Background
        Bkg = urwid.AttrWrap(HeadBodyFootFrame, 'Bg')

        #Empty field popup
        Empty = urwid.AttrWrap(urwid.Overlay(urwid.LineBox(texts.getEmptyFieldMessage(), title='|** Error **|'), Bkg, 'center', 40, 'middle', None), 'PopupMessageBg')

        #Search by ID received a letter. We are doomed!
        GotLetter = urwid.AttrWrap(urwid.Overlay(urwid.LineBox(texts.getGotLetterMessage(), title='|** Error **|'), Bkg, 'center', 40, 'middle', None), 'PopupMessageBg')

        #Record does not exist
        NoRecord = urwid.AttrWrap(urwid.Overlay(urwid.LineBox(texts.getNoRecordMessage(), title='|** Error **|'), Bkg, 'center', 40, 'middle', None), 'PopupMessageBg')

        return Bkg, Empty, GotLetter, NoRecord
#======================================
    def ShowSearchResultScreen(self, ListOfResults):
        '''This is the search result screen when searching by name/nickname/lastname'''
        global IntEdit

        ResultBoxColumns = [
                    urwid.AttrWrap(urwid.Text(('SearchBoxHeaderText', 'ID'), align='center'), 'SearchBoxHeaderBg'),
                    urwid.AttrWrap(urwid.Text(('SearchBoxHeaderText', 'Name'), align='center'), 'SearchBoxHeaderBg'),
                    urwid.AttrWrap(urwid.Text(('SearchBoxHeaderText', 'Last name'), align='center'), 'SearchBoxHeaderBg'),
                    urwid.AttrWrap(urwid.Text(('SearchBoxHeaderText', 'Birth date'), align='center'), 'SearchBoxHeaderBg')
                           ]

        #Let's put all the results in columns, k?
        ResTmp = []
        ResultToShow = []
        for List in ListOfResults:
            for Item in List:
                ResTmp.append(urwid.AttrWrap(urwid.Text(('Info', '%s' % Item), align='center'), 'Bg'))
            ResultToShow.append(urwid.Columns(ResTmp, 1))
            ResTmp = []

        IntEdit = urwid.AttrWrap(urwid.IntEdit(caption='Enter ID: '.rjust(15)), 'Field')
        ResultBox = urwid.ListBox(urwid.SimpleListWalker([
                                        urwid.Divider(),
                                        IntEdit,
                                        urwid.Divider(),
                                        urwid.Columns(ResultBoxColumns, 1),
                                                         ]+ResultToShow))

        #Footer
        Footer = urwid.AttrMap(urwid.Text(texts.getFooterSearchResultText(), align='center'), 'InfoFooter')

        #Header
        Header = urwid.AttrMap(urwid.Text(('InfoHeaderText', '%s / Search results / Found records: %d' % (texts.getHeaderText(__version__), len(ResultToShow))), align='center'), 'InfoHeader')

        HeadBodyFootFrame = urwid.Frame(footer=Footer, header=Header, body=ResultBox)

        #Background
        Bkg = urwid.AttrWrap(HeadBodyFootFrame, 'Bg')

        #Record does not exist
        NoRecord = urwid.AttrWrap(urwid.Overlay(urwid.LineBox(texts.getNoRecordMessage(), title='|** Error **|'), Bkg, 'center', 40, 'middle', None), 'PopupMessageBg')

        return Bkg, NoRecord
#======================================
    def ShowMain(self, Banner):
        '''The main screen'''
        
        #Footer
        Footer = urwid.AttrMap(urwid.Text(texts.getFooterMainText(), align='center'), 'InfoFooter')

        #Header
        Header = urwid.AttrMap(urwid.Text(('InfoHeaderText', '%s / Kulverstukas && Factionwars @ Evilzone.org' % (texts.getHeaderText(__version__))), align='center'), 'InfoHeader')

        #Banner
        #Banner = urwid.AttrWrap(urwid.Overlay(urwid.BigText('D0xBase %s' % __version__, urwid.font.HalfBlock7x7Font()), urwid.SolidFill(' '), 'center', None, 'top', None), 'BigText')

        #Message below the banner
        HeadBodyFootFrame = urwid.Frame(header=Header, body=texts.getMainPageText(Banner), footer=Footer)
        Bkg = urwid.AttrWrap(HeadBodyFootFrame, 'Bg')
        return Bkg
#======================================
    def CheckForChars(self, Item):
        '''Checks a string if it contains a letter.
           This is a part of the search method'''
        for Char in (string.lowercase+string.uppercase+' '):
            if Item.find(Char) != -1:
                return True
        return False
#======================================
    def GetResults(self, ListWithIDs):
        '''Receives a list of tuples with IDs
           and returns relevant data in array
           of tuples'''
        Result = []
        FinalResult = []
        for Item in ListWithIDs:
            Persons = database.getperson(Item[0])
            Result.append(Persons[0]) # ID
            Result.append(Persons[1]) # first name
            Result.append(Persons[2]) # last name
            Result.append(Persons[5]) # birth date
            FinalResult.append(Result)
            Result = []
        return FinalResult
#======================================
    def AddEditMenu(self, key):
        '''Adding and editing screen menu'''
        global EditFieldsList, Information, INPUT, CameToEdit, gap
        if (self.loop.widget == self.exit) or (self.loop.widget == self.WrongDate):
            if key in ('esc', 'enter'):
                self.loop.widget = self.MainScreen
                return
        elif (self.loop.widget == self.ConfirmCancel):
            if key in ('y', 'Y'):
                try:
                    self.loop = urwid.MainLoop(self.ShowMain(withBanner), palette, unhandled_input=self.MainScreenMenu)
                    self.loop.run()
                except UnicodeEncodeError:
                    self.loop = urwid.MainLoop(self.ShowMain(withoutBanner), palette, unhandled_input=self.MainScreenMenu)
                    self.loop.run()
            elif key in ('n', 'N'):
                self.loop.widget = self.MainScreen
                return
        elif (self.loop.widget == self.ReallyAdd):
            #if a record is to be modified, "CameToEdit" will be true
            if key in ('y', 'Y'):
                if (CameToEdit == True):
                    Information.insert(0, INPUT[0])
                    database.editperson(Information)
                else:
                    #Let's add that ish, finally!
                    database.addperson(Information, gap)
                self.loop.widget = self.Success
                return
            elif key in ('n', 'N'):
                self.loop.widget = self.MainScreen
                return
        elif key == 'esc':
            if (self.loop.widget == self.Success):
                if (CameToEdit == True):
                    INPUT = Information
                    Information = []
                    CameToEdit = False
                else:
                    Information = []
                    INPUT = database.getperson(gap)
                    gap = database.getNearestGap(); #get next position where to insert a record
                self.MainScreen, self.DeletionPopup, self.noMoreRecords = self.ShowInfo()
                self.loop = urwid.MainLoop(self.MainScreen, palette, unhandled_input=self.ViewScreenMenu)
                self.loop.run()
            else:
                if (config.get('main', 'confirm_add_cancel') == 'y'):
                    self.loop.widget = self.ConfirmCancel
                    return
                else:
                    try:
                        self.loop = urwid.MainLoop(self.ShowMain(withBanner), palette, unhandled_input=self.MainScreenMenu)
                        self.loop.run()
                    except UnicodeEncodeError:
                        self.loop = urwid.MainLoop(self.ShowMain(withoutBanner), palette, unhandled_input=self.MainScreenMenu)
                        self.loop.run()
        elif key == 'tab':
            tmpFocus = None
            pos = None
            tmpFocus, pos = EditFieldsList.get_focus()
            if (pos < 29):
                pos += 2
                EditFieldsList.set_focus(pos)
            else:
                EditFieldsList.set_focus(0)
        elif key == 'f2':
            #Get original place where the cursor was
            Hurr, Durr = EditFieldsList.get_focus()
            #Check if the Name field is filled
            EditFieldsList.set_focus(0)
            Yar, Yarr = EditFieldsList.get_focus()
            if (Yar.edit_text.strip() == ''):
                EditFieldsList.set_focus(0)
                self.loop.widget = self.exit
                return
            Information = []
            I = 0
            for I in [index for index in range(30) if ((index % 2) == 0)]:
                EditFieldsList.set_focus(I)
                Focus, pos = EditFieldsList.get_focus()
                Information.append(Focus.edit_text)
            #Set original position back
            EditFieldsList.set_focus(Durr)
            Date = datetime.date.today()
            #add the last modification time at the end
            Information.append('%d.%d.%d' % (Date.year, Date.month, Date.day))
            if (Information[4] != None) and (Information[4].strip() != ''):
                if (self.CheckDate(Information[4]) == False):
                    EditFieldsList.set_focus(8)
                    self.loop.widget = self.WrongDate #aww shizzle! letters in the date or wrong format?
                    return
            #Ask if you really reall want to add it :D
            self.loop.widget = self.ReallyAdd
            return
#======================================
    def ViewScreenMenu(self, key):
        '''This menu is for when viewing a record'''
        global INPUT, CameToEdit
        if (self.loop.widget == self.noMoreRecords):
            if key in ('esc', 'enter'):
                try:
                    self.loop = urwid.MainLoop(self.ShowMain(withBanner), palette, unhandled_input=self.MainScreenMenu)
                    self.loop.run()
                except UnicodeEncodeError:
                    self.loop = urwid.MainLoop(self.ShowMain(withoutBanner), palette, unhandled_input=self.MainScreenMenu)
                    self.loop.run()
        elif (self.loop.widget == self.DeletionPopup):
            if key in ('y', 'Y'):
                #If confirmed, delete him and show the next one
                #or the previous one, if deleted person was the last in DB
                database.deleteperson(INPUT[0])
                self.loop.widget = self.MainScreen
                lastPerson = database.getLastID();
                oldIndex = INPUT[0]
                INPUT = None
                if (lastPerson == 0):
                    self.loop.widget = self.noMoreRecords
                    return
                elif ((oldIndex >= lastPerson) and (oldIndex >= 1)):
                    while (INPUT is None):
                        oldIndex -= 1
                        INPUT = database.getperson(oldIndex)
                elif (oldIndex < lastPerson):
                    while (INPUT is None):
                        oldIndex += 1
                        INPUT = database.getperson(oldIndex)
                gap = database.getNearestGap();
                self.MainScreen, self.DeletionPopup, self.noMoreRecords = self.ShowInfo()
                self.loop = urwid.MainLoop(self.MainScreen, palette, unhandled_input=self.ViewScreenMenu)
                self.loop.run()
            elif key in ('n', 'N'):
                self.loop.widget = self.MainScreen
                return
        elif key in ('e', 'E'): #Edit screen
            CameToEdit = True
            self.MainScreen, self.exit, self.WrongDate, self.Success, self.ConfirmCancel, self.ReallyAdd = self.ShowEditor()
            self.loop = urwid.MainLoop(self.MainScreen, palette, unhandled_input=self.AddEditMenu)
            self.loop.run()
        elif key in ('a', 'A'): #Add screen
            self.MainScreen, self.exit, self.WrongDate, self.Success, self.ConfirmCancel, self.ReallyAdd = self.ShowAdd()
            self.loop = urwid.MainLoop(self.MainScreen, palette, unhandled_input=self.AddEditMenu)
            self.loop.run()
        elif key in ('d', 'D'): #Deletion of a record popup
            self.loop.widget = self.DeletionPopup
            return
        elif key in ('s', 'S'):  #Search screen
            self.MainScreen, self.Empty, self.GotLetter, self.NoRecord = self.ShowSearch()
            self.loop = urwid.MainLoop(self.MainScreen, palette, unhandled_input=self.SearchScreenMenu)
            self.loop.run()
        elif key == 'esc':
            try:
                self.loop = urwid.MainLoop(self.ShowMain(withBanner), palette, unhandled_input=self.MainScreenMenu)
                self.loop.run()
            except UnicodeEncodeError:
                self.loop = urwid.MainLoop(self.ShowMain(withoutBanner), palette, unhandled_input=self.MainScreenMenu)
                self.loop.run()
#======================================
    def SearchResultMenu(self, key):
        '''Menu for the found results'''
        global IntEdit, INPUT
        if (self.loop.widget == self.NoRecord):
            if key in 'esc':
                self.loop.widget = self.MainScreen
                return
        elif key == 'esc':  #Get back to the search screen bish!
            try:
                self.loop = urwid.MainLoop(self.ShowMain(withBanner), palette, unhandled_input=self.MainScreenMenu)
                self.loop.run()
            except UnicodeEncodeError:
                self.loop = urwid.MainLoop(self.ShowMain(withoutBanner), palette, unhandled_input=self.MainScreenMenu)
                self.loop.run()
        elif key == 'enter':
            if (IntEdit.edit_text == ''): return #nothing is entered...
            INPUT = database.getperson(IntEdit.edit_text)
            if (INPUT is None):
                self.loop.widget = self.NoRecord
                return
            self.MainScreen, self.DeletionPopup, self.noMoreRecords = self.ShowInfo()
            self.loop = urwid.MainLoop(self.MainScreen, palette, unhandled_input=self.ViewScreenMenu)
            self.loop.run()
        elif key in ('s', 'S'):  #Search
            self.MainScreen, self.Empty, self.GotLetter, self.NoRecord = self.ShowSearch()
            self.loop = urwid.MainLoop(self.MainScreen, palette, unhandled_input=self.SearchScreenMenu)
            self.loop.run()
        elif key in ('a', 'A'):  #Adding screen
            self.MainScreen, self.exit, self.WrongDate ,self.Success, self.ConfirmCancel, self.ReallyAdd = self.ShowAdd()
            self.loop = urwid.MainLoop(self.MainScreen, palette, unhandled_input=self.AddEditMenu)
            self.loop.run()
#======================================
    def SearchScreenMenu(self, key):
        '''Menu for the search screen'''
        global RadioButtons, INPUT, SearchField
        if (self.loop.widget == self.Empty) or (self.loop.widget == self.GotLetter) or (self.loop.widget == self.NoRecord):
            if key in ('esc', 'enter'):
                self.loop.widget = self.MainScreen
                return
        elif key == 'esc':
            try:
                self.loop = urwid.MainLoop(self.ShowMain(withBanner), palette, unhandled_input=self.MainScreenMenu)
                self.loop.run()
            except UnicodeEncodeError:
                self.loop = urwid.MainLoop(self.ShowMain(withoutBanner), palette, unhandled_input=self.MainScreenMenu)
                self.loop.run()
        elif key == 'enter':
            Hurr = SearchField.edit_text.strip()
            #Lets check if the field is empty, k?
            if (Hurr == ''): #oh shi- it is!?
                self.loop.widget = self.Empty #Display an error...
                return
            else:
                #Search by ID starts here
                if (RadioButtons[0].state == True):
                    if (self.CheckForChars(Hurr) == True): #search by ID received a letter!?
                        self.loop.widget = self.GotLetter #show an error
                        return
                    #Get some data from the database
                    INPUT = database.getperson(Hurr)
                    if (INPUT is None):
                        self.loop.widget = self.NoRecord
                        return
                    self.MainScreen, self.DeletionPopup, self.noMoreRecords = self.ShowInfo()
                    self.loop = urwid.MainLoop(self.MainScreen, palette, unhandled_input=self.ViewScreenMenu)
                    self.loop.run()

                elif (RadioButtons[1].state): #search by name
                    SearchIDs = database.search('name', Hurr)

                elif (RadioButtons[2].state): #search by last name
                    SearchIDs = database.search('lastname', Hurr)

                elif (RadioButtons[3].state): #search by nickname
                    SearchIDs = database.search('nickname', Hurr)
                    
                SearchIDs = self.GetResults(SearchIDs)
                self.MainScreen, self.NoRecord = self.ShowSearchResultScreen(SearchIDs)
                self.loop = urwid.MainLoop(self.MainScreen, palette, unhandled_input=self.SearchResultMenu)
                self.loop.run()
#======================================
    def MainScreenMenu(self, key):
        '''Main screen menu'''
        if key == 'esc':  #Quit
            raise Exception('\n'*100+'You have quit D0xBase %s. Have a nice day!'.rjust(50) % __version__+'\n'*10)
        elif key in ('s', 'S'):  #Search
            self.MainScreen, self.Empty, self.GotLetter, self.NoRecord = self.ShowSearch()
            self.loop = urwid.MainLoop(self.MainScreen, palette, unhandled_input=self.SearchScreenMenu)
        elif key in ('a', 'A'):  #Adding screen
            self.MainScreen, self.exit, self.WrongDate ,self.Success, self.ConfirmCancel, self.ReallyAdd = self.ShowAdd()
            self.loop = urwid.MainLoop(self.MainScreen, palette, unhandled_input=self.AddEditMenu)
        self.loop.run()
#======================================
    def Begin(self, whichScreen):
        '''Start everything'''
        if (whichScreen == 'main'):
            try:
                self.loop = urwid.MainLoop(self.ShowMain(withBanner), palette, unhandled_input=self.MainScreenMenu)
                self.loop.run()
            except UnicodeEncodeError:
                self.loop = urwid.MainLoop(self.ShowMain(withoutBanner), palette, unhandled_input=self.MainScreenMenu)
                self.loop.run()
        elif (whichScreen == 'add'):
            self.MainScreen, self.exit, self.WrongDate ,self.Success, self.ConfirmCancel, self.ReallyAdd = self.ShowAdd()
            self.loop = urwid.MainLoop(self.MainScreen, palette, unhandled_input=self.AddEditMenu)
        elif (whichScreen == 'search'):
            self.MainScreen, self.Empty, self.GotLetter, self.NoRecord = self.ShowSearch()
            self.loop = urwid.MainLoop(self.MainScreen, palette, unhandled_input=self.SearchScreenMenu)
        self.loop.run()
#======================================
parser = OptionParser()
parser.add_option('--screen',
                  help='',
                  metavar='main         Which screen to use to start D0xBase\n           add\n           search')
(options, args) = parser.parse_args()
options = vars(options)
#======================================
#Check if appropriate version is being used
if urwid.__version__ == '1.0.1':
    if (os.path.exists('d0xconfig.ini') == False):
        #If file does not exist then set default options, k
        config = wiz.setDefaults(config)
        wiz.writeToFile(config)
    else:
        #Well if it does then read it
        config.read('d0xconfig.ini')
        #Lets check integrity if the config file has the right
        #options and if not then set default for them
        if (config.has_section('main') == False): #oh snap! no section holding our options!?
            config = wiz.setDefaults(config)
            wiz.writeToFile(config)
        else: #ok so it does exist, huh
            if ((config.has_option('main', 'program_version') == False) or
                (wiz.checkAns(config.get('main', 'program_version') == False))):
                config.set('main', '# Whether or not to display program', '')
                config.set('main', '# version in all the screens, except main', '')
                config.set('main', 'program_version', 'y')
                
            if ((config.has_option('main', 'display_id_adding') == False) or
                (wiz.checkAns(config.get('main', 'display_id_adding')) == False)):
                config.set('main', '# a record that will be assigned to the new record', '')
                config.set('main', '# This will also affect the editing screen', '')
                config.set('main', 'display_id_adding', 'y')
                
            if ((config.has_option('main', 'display_id_viewing') == False) or
                (wiz.checkAns(config.get('main', 'display_id_viewing')) == False)):
                config.set('main', '\n# Display or not the ID of a record when viewing', '')
                config.set('main', 'display_id_adding', 'y')

            if ((config.has_option('main', 'confirm_add_cancel') == False) or
                (wiz.checkAns(config.get('main', 'confirm_add_cancel')) == False)):
                config.set('main', '\n# Display or not a confirmation dialog when you', '')
                config.set('main', '# want to quit adding a record', '')
                config.set('main', 'confirm_add_cancel', 'y')

            if ((config.has_option('main', 'default_search_method') == False) or
                (wiz.checkAns1(config.get('main', 'default_search_method')) == False)):
                config.set('main', '\n# Set the default search option', '')
                config.set('main', 'default_search_method', 'name')

            if ((config.has_option('main', 'default_screen') == False) or
                (wiz.checkAns2(config.get('main', 'default_screen')) == False)):
                config.set('main', '\n# Set the default screen to show on startup', '')
                config.set('main', 'default_screen', 'main')
                
            if (config.has_option('main', 'database_path') == False):
                config.set('main', '\n# Path where database is located.', '')
                config.set('main', '# Leave ./dox to have it in the same folder', '')
                config.set('main', 'database_path', './dox')
                
    #intialize database
    database =  d0xengine.Db(config.get('main', 'database_path'))
    #following command creates database file if it is missing with default record
    database.connect()
    gap = database.getNearestGap()
    
    if (options['screen'] == 'add'): FrontEnd().Begin('add')
    elif (options['screen'] == 'search'): FrontEnd().Begin('search')
    else: FrontEnd().Begin(config.get('main', 'default_screen'))
else:
    print 'Urwid version must be 1.0.1; Exiting.'
