'''
Started on: 2011.11.04
Last update: 2011.11.30
Author: Kulverstukas && Factionwars

=================================================
Copyright 2011 Kulverstukas, Factionwars

    This file is part of D0xBase.

    D0xBase is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation version 3

    D0xBase is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with D0xBase.  If not, see http://www.gnu.org/licenses/
=================================================

Shouts: Evilzone.org
You can contact us at: kulverwars@evilzone.org
--------
Description:
  This module is part of "D0xBase" project.
  Any modification without knowing what you are doing will result
  in unwanted behavior and can stop working.
  
  This module is part of front-end. Here is stored the text
  for D0xBase front-end.
--------
'''

import urwid, random

class d0xtext:
#======================================
    def __init__(self):
        '''Empty constructor'''
        pass
#======================================
    def RandomColor(self):
        '''Pick a random color for the main menu text'''
        ListOfColors = ['dark red', 'dark green', 'brown', 'dark blue',
                        'dark magenta', 'dark cyan', 'light gray',
                        'dark gray', 'light red', 'light green', 'yellow',
                        'light blue', 'light magenta', 'light cyan', 'default']
        Color = ListOfColors[random.randint(0, 14)]
        return Color
#======================================
    def getHeaderText(self, version):
        '''Accept version as an argument
        return header text'''
        return 'D0xBase version %s' % version
#======================================
    def getFooterViewText(self):
        '''Returns Footer text for record viewing screen'''
        return ('InfoFooterText',['Press ', ('InfoFooterHotkey', '"ESC"'), ' for main screen, ', ('InfoFooterHotkey', '"E"'), ' to edit, ', ('InfoFooterHotkey', '"A"'), ' to add, ', ('InfoFooterHotkey', '"D"'), ' to delete, ', ('InfoFooterHotkey', '"S"'), ' to search'])
#======================================
    def getFooterAddingText(self):
        '''Returns Footer text for record adding screen'''
        return ('InfoFooterText', ['Press ', ('InfoFooterHotkey', '"ESC"'), ' to Cancel, ', ('InfoFooterHotkey', '"F2"'), ' to add'])
#======================================
    def getFooterMainText(self):
        '''Returns text for the main screen'''
        return ('InfoFooterText', ['Press ', ('InfoFooterHotkey', '"ESC"'), ' to Quit, ', ('InfoFooterHotkey', '"A"'), ' to add, ', ('InfoFooterHotkey', '"S"'), ' to search'])
#======================================
    def getFooterSearchText(self):
        '''Returns text for the search screen'''
        return ('InfoFooterText', ['Press ', ('InfoFooterHotkey', '"ESC"'), ' for main screen'])
#======================================
    def getFooterSearchResultText(self):
        '''Returns text for the search result screen'''
        return ('InfoFooterText', ['Press ', ('InfoFooterHotkey', '"ESC"'), ' for main screen, ', ('InfoFooterHotkey', '"A"'), ' to add, ', ('InfoFooterHotkey', '"S"'), ' to search again'])
#======================================
    def getPalette(self):
        '''Returns a palette used for coloring the text'''
        return [
                ('Field', 'dark green, bold', 'black'), # information fields, like Name, Age etc.
                ('Info', 'dark green', 'black'), # information in fields
                ('Bg', 'black', 'black'), # screen background
                ('InfoFooterText', 'white', 'dark blue'), # footer text
                ('InfoFooterHotkey', 'dark cyan, bold', 'dark blue'), # hotkeys in footer text
                ('InfoFooter', 'black', 'dark blue'),  # footer background
                ('InfoHeaderText', 'white, bold', 'dark blue'), # header text
                ('InfoHeader', 'black', 'dark blue'), # header background
                ('BigText', self.RandomColor(), 'black'), # main menu banner text
                ('GeneralInfo', 'brown', 'black'), # main menu text
                ('LastModifiedField', 'dark cyan, bold', 'black'), # Last modified:
                ('LastModifiedDate', 'dark cyan', 'black'), # info in Last modified:
                ('PopupMessageText', 'black', 'dark cyan'), # popup message text
                ('PopupMessageBg', 'black', 'dark cyan'), # popup message background
                ('SearchBoxHeaderText', 'light gray, bold', 'dark cyan'), # field names in the search box
                ('SearchBoxHeaderBg', 'black', 'dark cyan'), # field name background in the search box
                ('OnFocusBg', 'white', 'dark magenta') # background when a widget is focused
               ]
#======================================
# Adding/editing screen warning/tips texts
    def getAddTips(self):
        '''Returns the information when adding a record'''
        return urwid.SimpleListWalker([
                urwid.Padding(urwid.Text(('GeneralInfo', '\n Tips and tricks filling this form:\n\n'\
                                          '  1. While filling the form you can paste '\
                                          'text to it using the mouse. The "Name" '\
                                          'field MUST be filled to add a record to the database\n\n'\
                                          '  2. Move up and down using  arrow keys. '\
                                          'You can also use "Page up" and "Page down" '\
                                          'to get to the first/last line.\n\n'\
                                          '  3. When filling the "Contact" field or the "Notes" '\
                                          'field, to move text to a new line, press "ENTER".\n\n'\
                                          '  4. When you are done filling the form, press "F2" '\
                                          'to save everything to the database. Not everything must '\
                                          'be filled in. For those fields that there is no info '\
                                          'you can leave them empty and edit the record later on.')), left=2)
                                        ])

    def getEmptyWarning(self):
        '''Returns a text for a warning if Name field is emty'''
        return urwid.Text(('PopupMessageText', 'Cannot add to the database.\n"Name" field must be filled! Letters must be used.\n\nPress "ESC" or "ENTER" to return'), align='center')
    
    def getWrongDateWarning(self):
        '''Returns a text for a warning if date format is wrong'''
        return urwid.Text(('PopupMessageText', 'Cannot add to the database.\nWrong date format!\nDate must be like YEAR.MONTH.DAY\n\nPress "ESC" or "ENTER" to return'), align='center')
    
    def getAddedMessage(self):
        '''Returns a text for a notice if record was added'''
        return urwid.Text(('PopupMessageText', 'Successfully added to the database!\n\nPress "ESC" or "ENTER" to return'), align='center')
    
    def getReallyCancelMessage(self):
        '''Returns a text for a confirmation message to cancel adding'''
        return urwid.Text(('PopupMessageText', 'Are you sure you want to cancel?\n[Y/N]'), align='center')
    
    def getReallyAddMessage(self):
        '''Returns a text for a confirmation message to add a record'''
        return urwid.Text(('PopupMessageText', 'Are you sure you want to add?\n[Y/N]'), align='center')
#======================================
# Search screen warning/tips texts
    def getSearchTips(self):
        '''Returns the information for searching screen'''
        return urwid.SimpleListWalker([
                        urwid.Padding(urwid.Text(('GeneralInfo', '\n Tips and tricks for searching:\n\n'\
                                                                 '  1. Searching by ID, you only need to enter '\
                                                                 'the ID of the person in the Database. '\
                                                                 'So, if you would enter "1337", you would get '\
                                                                 'a person whose ID is "1337"\n\n'\
                                                                 '  2. Searching by "Name", "Last name" or "Nickname", '\
                                                                 'only enter one of the above to get a list '\
                                                                 'of records matching that criteria\n\n'\
                                                                 '  3. To select how to search, use the arrow keys, '\
                                                                 'UP and DOWN, when the cursor is on a wanted box '\
                                                                 'press ENTER or SPACE to select it\n\n')), left=2),
                                              ])
                                              
    def getEmptyFieldMessage(self):
        '''Returns a text for a warning if the search field is empty'''
        return urwid.Text(('PopupMessageText', 'Cannot proceed with the search.\nNothing given as search criteria!\n\nPress "ESC" or "ENTER" to return'), align='center')

    def getGotLetterMessage(self):
        '''Returns a text for a warning if letter was received searching by ID'''
        return urwid.Text(('PopupMessageText', 'Cannot proceed with the search\nSearch by ID received a letter!\nMust only be numbers.\n\nPress "ESC" or "ENTER" to return'), align='center')

    def getNoRecordMessage(self):
        '''Returns a text for a warning that a record does not exist'''
        return urwid.Text(('PopupMessageText', 'Cannot proceed with the search\nRecord does not seem to exist\n\nPress "ESC" or "ENTER" to return'), align='center')
#======================================
    def getMainPageText(self, Banner):
        '''Returns a text for the main page'''
        return urwid.LineBox(urwid.AttrWrap(urwid.Overlay(urwid.LineBox(urwid.Padding(urwid.Text(('GeneralInfo', 'GNU General Public Licence\n\nThis file is part of D0xBase. D0xBase is free software: you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation version 3. D0xBase is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.\nYou should have received a copy of the GNU General Public License along with D0xBase. If not, see http://www.gnu.org/licenses/\n\nContact information\n\nIn case of any bugs, suggestions or just to say Thanks, please email us at kulverwars@evilzone.org ([Kulver]stukas+Faction[wars] :D)\nYou can get a copy of this application by going to http://newage.ql.lt/projects/python/d0xbase/'), align='center'), align='center', width='pack', left=3, right=3)), Banner, 'center', 150, 'bottom', None), 'GeneralInfo'))
#======================================
    def getNoRecordsWarning(self):
        '''Returns a warning when last person is deleted
        from the database before returning to the main screen'''
        return urwid.Text(('PopupMessageText', 'No more records in the database to show\n\nPress "ESC" or "ENTER" to return'), align='center')